#define __LIBRARY__
#include <stdio.h>
#include <string.h>
#include <qdos.h>
#include <sys/socket.h>
#include "qsockets.h"
#include <errno.h>
#include <fcntl.h>

int getpeername(int s, struct sockaddr *addr, int *addrlen)
{
    REGS_t in,out;
    int res;

    CHECK_SOCKET(s);
    
    in.D0 = IP_GETPEERNAME;
    in.D2 = *addrlen;
    in.D3 = -1;
    in.A0 = (addreg_t)getchid(s);
    in.A1 = (addreg_t)addr;
    if((res = neterrno(in.A0, qdos3(&in, &out))) == 0)
    {
        *addrlen = out.D1;
    }
    return res;
}
