#include <stdio.h>
#include <string.h>
#include <qdos.h>
#include <sys/socket.h>
#include "qsockets.h"
#include <errno.h>


struct in_addr inet_makeaddr(int net, int host)
{
    struct in_addr x;
    REGS_t in,out;
    int res;
    int ch;

    x.s_addr =(unsigned long) -1;
    
    if((ch = io_open("sck_", 0)) > 0)
    {
        in.D0 = IP_INET_MAKEADDR;
        in.D1 = net;
        in.D2 = host;
        in.D3 = -1;
        in.A0 = (addreg_t)ch;
        in.A2 = (addreg_t)&x;            
        res = neterrno(in.A0, qdos3(&in, &out));
        io_close(ch);
    }
    else
    {
        errno = EINVAL;
    }
    return x;
}
