#define __LIBRARY__
#include <stdio.h>
#include <string.h>
#include <qdos.h>
#include <sys/socket.h>
#include "qsockets.h"
#include <errno.h>
#include <fcntl.h>

int ioctl(int s, int action, void *val)

{
    REGS_t in,out;
    int res;

    CHECK_SOCKET(s);
    
    in.D0 = IP_IOCTL;
    in.D1 = action;
    in.D3 = -1;
    in.A0 = (addreg_t)getchid(s);
    in.A1 = (addreg_t)val;
    res = neterrno(in.A0, qdos3(&in, &out));
    return res;
}
