#include <errno.h>
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#ifdef __QDOS__
# include <qdos.h>
#endif

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

int main (int ac, char **av)
{
    struct sockaddr_in name;
    struct hostent *h;
    int done, sock, n;
    char buf[4096];
    char *s, *host;

    
    if ((sock = socket (AF_INET, SOCK_STREAM, 0)) == -1)
    {
	perror ("socket");
	exit (EXIT_FAILURE);
    }

    host = (ac == 2) ? *(av+1) :  (s = getenv("NNTPSERVER")) ? s : "localhost";
    
    if ((h = gethostbyname (host)) == NULL)
    {
	perror ("gethostbyname");
        exit(0);
    }

    name.sin_family = h->h_addrtype;
    name.sin_port = htons(119);
    name.sin_addr = *((struct in_addr *) h->h_addr);

    n = connect (sock, (struct sockaddr *) &name, sizeof (name));
    if (n)
    {
	perror ("connect");
        exit(0);
    }

    n = read(sock, buf, sizeof(buf));
    if(strncmp(buf,"200", 3) == 0)
    {
        write(sock,"mode reader\r\n", sizeof ("mode reader\r\n")-1);
        n = read(sock, buf, sizeof(buf));
        printf("Read %d\n%.*s", n, n, buf);
        write(sock, "newnews maus.sys.ql.int 980507 000000\r\n",
              sizeof("newnews maus.sys.ql.int 980507 000000\r\n")-1);
    }

    for(done = 0; !done; )
    {
        n =  read(sock, buf, sizeof(buf));
        printf("Read (%d) %d\n%.*s", sizeof(buf), n, n, buf);
        for(s = buf; n && !(done = *s == '\n' && *(s+1) == '.'); n--,s++)
            ; /* */
    }
    return 0;
}

